<ul class="breadcrumb">
    <li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
    <li><?= $this->translate('directory_module_title') ?></li>
    <li class="active"><?= $this->translate('contact_nav_list') ?></li>
</ul>

<h1 class="page-title">
    <?= $this->icon('contact') ?> <?= $this->translate('contact_module_title') ?>
</h1>

<div class="row row-padding">
    <div class="col-xs-12">
        <div class="panel" ng-controller="contactListController as self">
            <table-builder options="self.options" items="self.contacts" class="table-builder">
                <div class="panel-heading">
                    <?= $this->translate('contact_nav_list') ?>
                    <div class="panel-heading-right">
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_remove_from_list') ?>">
                            <?= $this->icon('eraser', 'fa-fw pointer', ['ng-click' => '__tb.removeFromList()']) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                            <?= $this->icon('excel', 'fa-fw pointer', ['ng-click' => '__tb.exportExcel()']) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_refresh') ?>">
                            <?= $this->icon('refresh', 'fa-fw pointer', ['ng-click' => '__tb.loadData()']) ?>
                        </div>
                    </div>
                </div>
                <div class="panel-body">
                    <div class="row">
                        <div class="col-sm-4">
                            <div class="table-filters little-panel">
                                <div class="title table-filters-header">
                                    <div class="input-group">
                                        <div class="input-group-addon pointer" data-toggle="collapse" href="#filters-collapsed">
                                            <?= $this->icon('filters', 'fa-fw') ?>
                                            <span class="caret"></span>
                                        </div>
                                        <input type="text" placeholder="<?= $this->translate('search', null, null, false) ?>" class="form-control"
                                               ng-model="self.fullText" id="full-text" on-enter="self.fullTextSearch()"/>
                                        <div class="input-group-addon pointer" ng-click="self.fullTextSearch()">
                                            <?= $this->icon('search', 'fa-fw') ?>
                                        </div>
                                    </div>
                                </div>
                                <div id="filters-collapsed" class="body collapse">
                                    <?= $this->tableFilter(
                                        '__tb.apiParams.search.data.filters',
                                        $this->contactFilters()
                                    ); ?>
                                    <div class="row">
                                        <div class="col-xs-6">
                                            <button class="btn" ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
                                        </div>
                                        <div class="col-xs-6 text-right">
                                            <button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
                                                <?= $this->icon('search', 'fa-fw') ?>
                                                <?= $this->translate('table_filter_button') ?>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-sm-4">
                            <table-builder-columns with-duplicate="true" tooltip="<?= $this->translate('duplicate_tooltip') ?>"></table-builder-columns>
                        </div>
                        <?php if ($this->acl()->isAllowed('application:e:query:r')) : ?>
                        <div class="col-sm-4">
                            <table-builder-queries></table-builder-queries>
                        </div>
                        <?php endif; ?>
                    </div>
                    <div class="row">
                        <div class="col-xs-12">
                            <form name="contactForm">
                                <table table-builder-table class="table table-bordered table-condensed table-hover">
                                    <thead>
                                        <tr>
                                            <th tb-column tb-name="selection" class="checkbox-column"><input type="checkbox" ng-model="__tb.selection"/></th>
                                            <th tb-column tb-name="id" tb-toggle="true" tb-sortable="true"><?= $this->translate('contact_field_id') ?></th>
                                            <th tb-column tb-name="gender" tb-toggle="true" tb-sortable="true"><?= $this->translate('contact_field_gender') ?></th>
                                            <th tb-column tb-name="lastName" tb-sortable="true" tb-toggle="true"><?= $this->translate('contact_field_lastName') ?></th>
                                            <th tb-column tb-name="firstName" tb-sortable="true" tb-toggle="true"><?= $this->translate('contact_field_firstName') ?></th>
                                            <th tb-column tb-name="email" tb-toggle="true" tb-sortable="true"><?= $this->translate('contact_field_email') ?></th>
                                            <th tb-column tb-name="linksStr" tb-toggle="true" tb-sortable="false"><?= $this->translate('contact_field_linksStr') ?></th>
                                            <th tb-column tb-name="phone" tb-toggle="true" tb-sortable="true"><?= $this->translate('contact_field_phone') ?></th>
                                            <th tb-column tb-name="portable" tb-toggle="true" tb-sortable="true"><?= $this->translate('contact_field_portable') ?></th>
                                            <th tb-column tb-name="zipcode" tb-toggle="true" tb-sortable="true" tb-hidden="true"><?= $this->translate('contact_field_zipcode') ?></th>
                                            <th tb-column tb-name="country" tb-toggle="true" tb-sortable="true" tb-hidden="true"><?= $this->translate('contact_field_country') ?></th>
                                            <th tb-column tb-name="city" tb-toggle="true" tb-sortable="true" tb-hidden="true"><?= $this->translate('contact_field_city') ?></th>
                                            <th tb-column tb-name="addressLine1" tb-toggle="true" tb-sortable="true" tb-hidden="true"><?= $this->translate('contact_field_addressLine1') ?></th>
                                            <th tb-column tb-name="addressLine2" tb-toggle="true" tb-sortable="true" tb-hidden="true"><?= $this->translate('contact_field_addressLine2') ?></th>
                                            <?php
                                            if ($this->module()->isActive('keyword')) {
                                                foreach ($this->groups as $group) {
                                                    echo '<th tb-column tb-name="keyword' . $group->getId() . '" tb-sortable="false" tb-toggle="true">' . $group->getName() . '</th>';
                                                }
                                            }
                                            ?>
                                            <th tb-column tb-name="createdAt" tb-toggle="true" tb-sortable="true" tb-hidden="true"><?= $this->translate('contact_field_createdAt') ?></th>
                                            <th tb-column tb-name="updatedAt" tb-toggle="true" tb-sortable="true" tb-hidden="true"><?= $this->translate('contact_field_updatedAt') ?></th>
                                            <th tb-column tb-name="actions" class="actions-column"></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr ng-repeat="contact in self.contacts" ng-class="{editing: self.editedLine == contact}">
                                            <td><input type="checkbox" ng-model="contact.selected"/></td>
                                            <td>{{contact.id}}</td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== contact">
                                                    {{ 'contact_gender_' + contact.gender | translate }}
                                                    <?= $this->icon('inline-edit', '', [
                                                            'ng-click' => 'self.editLine(contact)',
                                                            'ng-if' => 'contact._rights.update'
                                                    ]) ?>
                                                </span>
                                                <span ng-if="self.editedLine == contact">
                                                    <select ng-model="self.editedLineFields.gender"
                                                            class="form-control input-sm">
                                                        <option></option>
                                                        <?php foreach (\Core\Entity\Contact\AbstractPerson::getGenders() as $gender): ?>
                                                            <option value="<?= $gender ?>">
                                                                <?= $this->translate('contact_gender_' . $gender) ?>
                                                            </option>
                                                        <?php endforeach ?>
                                                    </select>
                                                    <field-errors field="gender" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== contact">
                                                    <a ng-if="contact._rights.read" href="<?= $this->url('directory/contact/form') ?>/{{contact.id}}">{{contact.lastName}}</a>
                                                    <span ng-if="!contact._rights.read">{{contact.lastName}}</span>

                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(contact)', 'ng-if' => 'contact._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == contact">
                                                    <input type="text" class="form-control input-sm"  ng-model="self.editedLineFields.lastName" required />
                                                    <field-errors field="lastName" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== contact">
                                                    <a ng-if="contact._rights.read" href="<?= $this->url('directory/contact/form') ?>/{{contact.id}}">{{contact.firstName}}</a>
                                                    <span ng-if="!contact._rights.read">{{contact.firstName}}</span>

                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(contact)', 'ng-if' => 'contact._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == contact">
                                                    <input type="text" class="form-control input-sm"  ng-model="self.editedLineFields.firstName" required />
                                                    <field-errors field="firstName" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== contact">
                                                    {{contact.email}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(contact)', 'ng-if' => 'contact._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == contact">
                                                    <input type="email" class="form-control input-sm"  ng-model="self.editedLineFields.email" />
                                                    <field-errors field="email" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td>
                                                <span ng-repeat="link in contact.linksArr">
                                                    {{ link }} <br>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== contact">
                                                    {{contact.phone}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(contact)', 'ng-if' => 'contact._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == contact">
                                                    <input type="text" class="form-control input-sm"  ng-model="self.editedLineFields.phone"/>
                                                    <field-errors field="phone" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== contact">
                                                    {{contact.portable}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(contact)', 'ng-if' => 'contact._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == contact">
                                                    <input type="text" class="form-control input-sm"  ng-model="self.editedLineFields.portable"/>
                                                    <field-errors field="portable" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== contact">
                                                    {{contact.zipcode}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(contact)', 'ng-if' => 'contact._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == contact">
                                                    <input type="text" class="form-control input-sm"  ng-model="self.editedLineFields.zipcode" />
                                                    <field-errors field="zipcode" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== contact">
                                                    {{contact.country}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(contact)', 'ng-if' => 'contact._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == contact">
                                                    <input type="text" class="form-control input-sm"  ng-model="self.editedLineFields.country" />
                                                    <field-errors field="country" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== contact">
                                                    {{contact.city}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(contact)', 'ng-if' => 'contact._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == contact">
                                                    <input type="text" class="form-control input-sm"  ng-model="self.editedLineFields.city" />
                                                    <field-errors field="city" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== contact">
                                                    {{contact.addressLine1}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(contact)', 'ng-if' => 'contact._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == contact">
                                                    <input type="text" class="form-control input-sm"  ng-model="self.editedLineFields.addressLine1" />
                                                    <field-errors field="addressLine1" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== contact">
                                                    {{contact.addressLine2}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(contact)', 'ng-if' => 'contact._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == contact">
                                                    <input type="text" class="form-control input-sm"  ng-model="self.editedLineFields.addressLine2" />
                                                    <field-errors field="addressLine2" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <?php
                                                if ($this->module()->isActive('keyword')) {
                                                    foreach ($this->groups as $group) {
                                                        echo '<td class="editable">';
                                                            echo '<span class="comma-separated" ng-show="self.editedLine !== contact">';
                                                                echo '<span ng-repeat="keyword in contact.keywords[' . $group->getId() . ']">{{keyword.name}}</span>';
                                                                echo $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(contact)', 'ng-if' => 'contact._rights.update']);
                                                            echo '</span>';
                                                            echo '<span ng-if="self.editedLine == contact">';
                                                                echo '<keyword-select ng-model="self.editedLineFields.keywords[' . $group->getId() . ']" multiple="' . ($group->isMultiple() ? 'true' : 'false') . '" configuration="{ service : { apiParams : { search: { data: { filters: { group : { op: \'eq\', val: ' . $group->getId() . ' } } } } } } }" form="indicatorForm"></keyword-select>';
                                                            echo '</span>';
                                                        echo '</td>';
                                                    }
                                                }
                                            ?>
                                            <td>{{contact.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                            <td>{{contact.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                            <td>
                                                <div class="btn-group btn-group-actions" ng-if="self.editedLine != contact">
                                                    <?php if ($this->acl()->isAllowed('directory:e:contact:r')) : ?>
                                                        <a ng-if="contact._rights.read"
                                                           href="<?= $this->url('directory/contact/form') ?>/{{contact.id}}"
                                                           class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_edit') ?>">
                                                            <?= $this->icon('edit') ?>
                                                        </a>
                                                    <?php endif; ?>

                                                    <?php if ($this->acl()->isAllowed('directory:e:contact:c')): ?>
                                                        <a class="btn btn-xs btn-default" ng-click="self.duplicate(contact)" tooltip="<?= $this->translate('tooltip_copy') ?>">
                                                            <?= $this->icon('duplicate'); ?>
                                                        </a>
                                                    <?php endif; ?>

                                                    <?php if ($this->acl()->isAllowed('directory:e:contact:c')): ?>
                                                        <a class="btn btn-xs btn-default" ng-click="self.showFusionModal(contact)" tooltip="<?= $this->translate('tooltip_fusion') ?>">
                                                            <?= $this->icon('fusion'); ?>
                                                        </a>
                                                    <?php endif; ?>

                                                    <?php if ($this->acl()->isAllowed('directory:e:contact:d')) : ?>
                                                        <a ng-if="contact._rights.delete" href="" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>" ng-click="self.deleteContact(contact)">
                                                            <?= $this->icon('delete') ?>
                                                        </a>
                                                    <?php endif; ?>
                                                </div>
                                                <div class="btn-group btn-group-actions" ng-if="self.editedLine == contact">
                                                    <button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(contact)" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
                                                        <?= $this->icon('save') ?>
                                                    </button>
                                                    <button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
                                                        <?= $this->icon('close') ?>
                                                    </button>
                                                </div>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </form>
                        </div>
                    </div>
                </div>
            </table-builder>
            <div class="modal" id="fusionModal">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h4 class="modal-title"><?= $this->translate('contact_fusion_title') ?></h4>
                        </div>
                        <div class="modal-body">
                            <div class="row" style="margin-bottom: 10px;">
                                <div class="col-xs-12">
                                    <div class="form-group">
                                        <label>
                                            <?= $this->translate('fusion_field_contactToFusion') ?> :
                                        </label>
                                        {{ self.fusion.contactToFusion.id }} -- {{ self.fusion.contactToFusion.name }}
                                    </div>
                                    <div class="form-group">
                                        <label style="display: block;">
                                            <?= $this->translate('fusion_field_type') ?>
                                        </label>
                                        <label style="font-weight: normal;">
                                            <input ng-model="self.fusion.type"
                                                   value="duplicate"
                                                   type="radio">
                                            Dupliquer
                                        </label>
                                        <label style="margin-left: 5px; font-weight: normal;">
                                            <input ng-model="self.fusion.type"
                                                   value="transfer"
                                                   type="radio">
                                            Transférer
                                        </label>
                                    </div>
                                    <div class="form-group">
                                        <label for="fusion.contactToKeep">
                                            <?= $this->translate('fusion_field_contactToKeep') ?>
                                        </label>
                                        <contact-select ng-model="self.fusion.contactToKeep"></contact-select>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-default" type="button" data-dismiss="modal">
                                <?= $this->translate('close') ?>
                            </button>

                            <button class="btn btn-submit" ng-disabled="self.loading.fusion"
                                    ng-click="self.doFusion()">
                                <?= $this->icon('loading', '', ['ng-if' => 'self.loading.fusion']) ?>
                                <?= $this->translate('fusion') ?>
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<?php
    $fabLinks = [];

    if ($this->acl()->isAllowed('directory:e:contact:c')) {
        $fabLinks[] = [
            'href' => $this->url('directory/contact/form'),
            'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('contact_nav_form')
        ];
        $fabLinks[] = [
            'href' => $this->url('import', ['entity' => 'contact']),
            'text' => $this->icon('import', 'fa-fw') . ' ' . $this->translate('contact_nav_import')
        ];
        $fabLinks[] = [
            'href' => $this->url('import', ['entity' => 'contactJobStructure']),
            'text' => $this->icon('import', 'fa-fw') . ' ' . $this->translate('structure_nav_import_links')
        ];
    }

    echo $this->fabMenu($fabLinks);
?>

<?php
$this->angular('js/src/keyword/directive/keywordSelect.js');
$this->angular('js/src/directory/directive/structureSelect.js');
$this->angular('js/src/directory/directive/jobSelect.js');
$this->angular('js/src/directory/directive/contactEmailSelect.js');
$this->angular('js/src/directory/directive/contactSelect.js');

$this->angular('js/src/keyword/service/keyword.js');
$this->angular('js/src/application/query/service/query.js');

$this->angular('js/src/directory/service/structure.js');
$this->angular('js/src/directory/service/job.js');
$this->angular('js/src/directory/service/contact.js');
$this->angular('js/src/directory/service/contact-email.js');
$this->angular('js/src/directory/controller/contact/list.js');